UVA之1121 - Subsequence

简介:

【题目】

A sequence of N positive integers (10 < N < 100 000), each of them less than or equal 10000, and a positive integer S (S < 100 000 000) are given. Write a program to find the minimal length of the subsequence of consecutive elements of the sequence, the sum of which is greater than or equal to S.

Input 

Many test cases will be given. For each test case the program has to read the numbers N and S, separated by an interval, from the first line. The numbers of the sequence are given in the second line of the test case, separated by intervals. The input will finish with the end of file.

Output 

For each the case the program has to print the result on separate line of the output file. If there isn't such a subsequence, print 0 on a line by itself.

Sample Input 

10 15 
5 1 3 5 10 7 4 9 2 8 
5 11 
1 2 3 4 5

Sample Output 

2 
3

【分析】

本题最直接的思路是二重循环,枚举子序列的起点和终点。代码如下(输入数据已存入数组A[1]~A[n])。

 

int ans = n+1;
for(int i = 1; i <= n; i++)
  for(int j = i; j <= n; j++) {
    int sum = 0;
    for(int k = i; k <= j; k++) sum += A[k];
    if(sum >= S) ans = min(ans, j-i+1);
  }
printf("%d\n", ans == n+1 ? 0 : ans);

很可惜,上述程序的时间复杂度是O(n3)的,因此,当n达到100 000的规模后,程序将无能为力。有一个方法可以降低时间复杂度,即常见的前缀和技巧。令Bi=A1+A2++Ai,规定B0=0,则可以在O(1)时间内求出子序列的值:Ai+Ai+1+…+Aj=Bj-Bi-1。这样,时间复杂度降为O(n2),代码如下。

 

B[0] = 0;
for(int i = 1; i <= n; i++) B[i] = B[i-1] + A[i];
int ans = n+1;
  for(int i = 1; i <= n; i++)
    for(int j = i; j <= n; j++)
      if(B[j] - B[i-1] >= S) ans = min(ans, j-i+1);
printf("%d\n", ans == n+1 ? 0 : ans);

遗憾的是,本题的数据规模太大,O(n2)时间复杂度的算法也太慢。不难发现,只要同时枚举起点和终点,时间复杂度不可能比O(n2)更低,所以必须另谋他路。比如,是否可以不枚举终点,只枚举起点,或者不枚举起点,只枚举终点呢?

我们首先试试只枚举终点。对于终点j,我们的目标是要找到一个让Bj-Bi-1≥S,且i尽量大(i越大,序列长度j-i+1就越小)的i值,也就是找一个让Bi-1≤Bj-S最大的i。考虑图1-29所示的序列。


当j=5时,B5=12,因此目标是找一个Bi-1≤12-7=5的最大i。注意到B是递增的(别忘了,本题中所有Ai均为整数),所以可以用二分查找。


【代码】

/*********************************
*   日期:2014-5-14
*   作者:SJF0115
*   题号: 1121 - Subsequence
*   地址:http://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&category=246&page=show_problem&problem=3562
*   来源:UVA
*   结果:Accepted
**********************************/
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <string.h>
using namespace std;

#define N 100001

int A[N];
int B[N];

//二分查找最接近target但不大于target
int BinarySerach(int target,int R){
    int L = 0;
    int mid = 0;
    while(L < R){
        mid = L + (R - L) / 2;
        if(B[mid] > target){
            R = mid;
        }
        else{
            L = mid + 1;
        }
    }
    return L;
}

int main(){
    int n,s,i,j;
    //freopen("C:\\Users\\wt\\Desktop\\acm.txt","r",stdin);
    while(scanf("%d %d",&n,&s) != EOF){
        int minLen = n+1;
        B[0] = 0;
        for(i = 1;i <= n;i++){
            scanf("%d",&A[i]);
            //序列前缀和
            B[i] = B[i-1] + A[i];
        }
        for(j = 1;j <= n;j++){
            int target = B[j] - s;
            //二分查找
            int index = BinarySerach(target,j-1);
            if(index > 0){
                minLen = min(minLen,j-index+1);
            }
        }
        //没有满足条件的序列
        if(minLen == n+1){
            minLen = 0;
        }
        cout<<minLen<<endl;
    }//while
    return 0;
}


【相似题目】

编程之美之2.14 求数组的子数组之和的最大值


目录
相关文章
|
索引
LeetCode 392. Is Subsequence
给定字符串 s 和 t ,判断 s 是否为 t 的子序列。 你可以认为 s 和 t 中仅包含英文小写字母。字符串 t 可能会很长(长度 ~= 500,000),而 s 是个短字符串(长度 <=100)。 字符串的一个子序列是原始字符串删除一些(也可以不删除)字符而不改变剩余字符相对位置形成的新字符串。(例如,"ace"是"abcde"的一个子序列,而"aec"不是)。
94 0
LeetCode 392. Is Subsequence
LeetCode 376. Wiggle Subsequence
如果连续数字之间的差严格地在正数和负数之间交替,则数字序列称为摆动序列。第一个差(如果存在的话)可能是正数或负数。少于两个元素的序列也是摆动序列。
88 0
LeetCode 376. Wiggle Subsequence
HDU 4632 Palindrome subsequence(动态规划)
HDU 4632 Palindrome subsequence(动态规划)
67 0
HDU 4632 Palindrome subsequence(动态规划)
|
机器学习/深度学习 网络架构
题解 UVA10212 【The Last Non-zero Digit.】
题目链接 这题在学长讲完之后和看完题解之后才明白函数怎么构造。这题构造一个$f(n)$$f(n)$ $=$ $n$除以 $2^{a}$ $*$ $5^{b}$ ,$a$ , $b$ 分别是 $n$ 质因数分解后$2,5$的个数。
1225 0
|
机器学习/深度学习
Uva - 12050 Palindrome Numbers【数论】
题目链接:uva 12050 - Palindrome Numbers   题意:求第n个回文串 思路:首先可以知道的是长度为k的回文串个数有9*10^(k-1),那么依次计算,得出n是长度为多少的串,然后就得到是长度为多少的第几个的回文串了,有个细节注意的是, n计算完后要-1! 下面给出A...
832 0
[UVa OJ] Longest Common Subsequence
This is the classic LCS problem. Since it only requires you to print the maximum length, the code can be optimized to use only O(m) space (see here).
769 0